scala.tools.nsc.backend.icode.TypeKinds

# ARRAY

###
Related Doc: package TypeKinds

#### final case class ARRAY(elem: ICodes.TypeKind) extends ICodes.TypeKind with Product with Serializable

Source
  TypeKinds.scala

Linear Supertypes
Serializable, java.io.Serializable, Product, Equals, ICodes.TypeKind, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ARRAY
2. Serializable
3. Serializable
4. Product
5. Equals
6. TypeKind
7. AnyRef
8. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ARRAY(elem: ICodes.TypeKind)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodes.ARRAY to any2stringadd[ICodes.ARRAY] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodes.ARRAY, B)

   Implicit information
     This member is added by an implicit conversion from ICodes.ARRAY to ArrowAssoc[ICodes.ARRAY] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### def <:<(other: ICodes.TypeKind): Boolean

   Array subtyping is covariant, as in Java.

   Array subtyping is covariant, as in Java. Necessary for checking code that interacts with Java.

   Definition Classes
     ARRAY → TypeKind

6. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

7. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

9. #### def dimensions: Int

   The number of dimensions for array types.

   The number of dimensions for array types.

   Definition Classes
     ARRAY → TypeKind

10. #### val elem: ICodes.TypeKind

11. #### def elementKind: ICodes.TypeKind

    The ultimate element type of this array.

12. #### def ensuring(cond: (ICodes.ARRAY) ⇒ Boolean, msg: ⇒ Any): ICodes.ARRAY

    Implicit information
      This member is added by an implicit conversion from ICodes.ARRAY to Ensuring[ICodes.ARRAY] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: (ICodes.ARRAY) ⇒ Boolean): ICodes.ARRAY

    Implicit information
      This member is added by an implicit conversion from ICodes.ARRAY to Ensuring[ICodes.ARRAY] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodes.ARRAY

    Implicit information
      This member is added by an implicit conversion from ICodes.ARRAY to Ensuring[ICodes.ARRAY] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean): ICodes.ARRAY

    Implicit information
      This member is added by an implicit conversion from ICodes.ARRAY to Ensuring[ICodes.ARRAY] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodes.ARRAY to StringFormat[ICodes.ARRAY] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### def isArrayType: Boolean

    Definition Classes
      ARRAY → TypeKind

21. #### final def isAssignabledTo(other: ICodes.TypeKind): Boolean

    this is directly assignable to other if no coercion or casting is needed to convert this to other.

    this is directly assignable to other if no coercion or casting is needed to convert this to other. It's a distinct relationship from <:< because on the JVM, BOOL, BYTE, CHAR, SHORT need no coercion to INT even though JVM arrays are covariant, ARRAY[SHORT] is not a subtype of ARRAY[INT]

    Definition Classes
      TypeKind

22. #### def isBoxedType: Boolean

    Definition Classes
      TypeKind

23. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

24. #### def isIntSizedType: Boolean

    On the JVM, BOOL, BYTE, CHAR, SHORT, and INT are like Ints for the purposes of calculating the lub.

    On the JVM, BOOL, BYTE, CHAR, SHORT, and INT are like Ints for the purposes of calculating the lub.

    Definition Classes
      TypeKind

25. #### def isIntegralType: Boolean

    On the JVM, similar to isIntSizedType except that BOOL isn't integral while LONG is.

    On the JVM, similar to isIntSizedType except that BOOL isn't integral while LONG is.

    Definition Classes
      TypeKind

26. #### final def isInterfaceType: Boolean

    Definition Classes
      TypeKind

27. #### final def isNothingType: Boolean

    Definition Classes
      TypeKind

28. #### final def isNullType: Boolean

    Definition Classes
      TypeKind

29. #### final def isNumericType: Boolean

    Definition Classes
      TypeKind

30. #### def isRealType: Boolean

    On the JVM, FLOAT and DOUBLE.

    On the JVM, FLOAT and DOUBLE.

    Definition Classes
      TypeKind

31. #### final def isRefOrArrayType: Boolean

    Definition Classes
      TypeKind

32. #### def isReferenceType: Boolean

    Definition Classes
      TypeKind

33. #### def isValueType: Boolean

    Definition Classes
      TypeKind

34. #### def isWideType: Boolean

    Is this type a category 2 type in JVM terms? (ie, is it LONG or DOUBLE?)

    Is this type a category 2 type in JVM terms? (ie, is it LONG or DOUBLE?)

    Definition Classes
      TypeKind

35. #### def maxType(other: ICodes.TypeKind): ICodes.TypeKind

    Approximate `lub`.

    Approximate `lub`. The common type of two references is always AnyRef. For 'real' least upper bound wrt to subclassing use method 'lub'.

    Definition Classes
      ARRAY → TypeKind

36. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

38. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

40. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      ARRAY → AnyRef → Any

41. #### def toType: Global.Type

    Definition Classes
      TypeKind

42. #### def uncomparable(other: ICodes.TypeKind): Nothing

    Attributes
      protected
    Definition Classes
      TypeKind

43. #### def uncomparable(thisKind: String, other: ICodes.TypeKind): Nothing

    Attributes
      protected
    Definition Classes
      TypeKind

44. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### def →[B](y: B): (ICodes.ARRAY, B)

    Implicit information
      This member is added by an implicit conversion from ICodes.ARRAY to ArrowAssoc[ICodes.ARRAY] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from ICodes.TypeKind

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodes.ARRAY to any2stringadd[ICodes.ARRAY]

### Inherited by implicit conversion StringFormat from ICodes.ARRAY to StringFormat[ICodes.ARRAY]

### Inherited by implicit conversion Ensuring from ICodes.ARRAY to Ensuring[ICodes.ARRAY]

### Inherited by implicit conversion ArrowAssoc from ICodes.ARRAY to ArrowAssoc[ICodes.ARRAY]

### Ungrouped